Graphics3D 800,600,32,2
SetBuffer BackBuffer()
Include "drawtex.bb"
AppTitle "random carcassone generator By Kate Barrett"

Global debugtileedge=LoadTexture("tileedge.png",2)
Global tilestex=LoadAnimTexture("tiles.png",1,512/7,1024/12,0,7*12)

Type boxtile
Field corner[4],no
Field placed
End Type
Global boxtileplace
Function newboxtile(N,E,S,W)
b.boxtile=New boxtile
b\corner[0]=N
b\corner[1]=E
b\corner[2]=S
b\corner[3]=W
b\no=boxtileplace
boxtileplace=boxtileplace+1
End Function
newboxtile(0,2,0,0)
newboxtile(0,2,2,2)
newboxtile(0,2,0,2)
newboxtile(0,0,2,2)
newboxtile(0,2,2,0)
newboxtile(0,0,2,2)
newboxtile(0,0,3,0)
newboxtile(0,1,1,0)
newboxtile(2,2,2,1)
newboxtile(0,0,0,2)
newboxtile(2,2,0,0)
newboxtile(2,2,2,2)
newboxtile(2,0,2,2)
newboxtile(3,0,3,0)
newboxtile(1,2,1,0)
newboxtile(2,1,2,2)
newboxtile(0,1,1,1)
newboxtile(0,2,1,1)
newboxtile(2,2,0,2)
newboxtile(2,0,2,2)
newboxtile(3,0,3,0)
newboxtile(1,2,1,0)
newboxtile(2,1,1,2)
newboxtile(1,1,1,1)
newboxtile(1,3,3,1)
newboxtile(0,3,1,3)
newboxtile(2,3,2,3)
newboxtile(3,0,0,3)
newboxtile(1,0,1,0)
newboxtile(1,1,2,0)
newboxtile(1,2,2,1)
newboxtile(3,3,2,2)
newboxtile(1,3,1,3)
newboxtile(2,3,1,3)
newboxtile(0,0,3,3)
newboxtile(1,2,1,0)
newboxtile(2,1,1,2)
newboxtile(2,2,1,1)
newboxtile(2,1,1,2)
newboxtile(1,1,0,1)
newboxtile(1,0,0,1)
newboxtile(3,0,0,0)
newboxtile(1,1,1,0)
newboxtile(1,1,2,1)
newboxtile(1,0,0,1)
newboxtile(1,0,1,0)
newboxtile(0,1,0,0)
newboxtile(0,0,1,1)
newboxtile(0,0,2,0)
newboxtile(1,0,1,0)
newboxtile(2,0,2,0)
newboxtile(0,0,1,0)
newboxtile(1,2,1,0)
newboxtile(0,2,0,2)
newboxtile(1,2,2,2)
newboxtile(2,0,0,2)
newboxtile(1,1,2,0)
newboxtile(2,1,1,1)
newboxtile(1,1,2,1)
newboxtile(1,0,0,1)
newboxtile(0,0,0,0)
newboxtile(2,2,0,0)
newboxtile(0,0,2,2)
newboxtile(2,0,0,0)
newboxtile(1,0,1,0)
newboxtile(2,0,2,0)
newboxtile(0,0,0,0)
newboxtile(0,0,0,0)
newboxtile(0,0,0,0)
newboxtile(2,0,2,0)
newboxtile(0,1,1,0)
newboxtile(1,0,1,1)
newboxtile(2,1,1,0)
newboxtile(0,1,0,1)
newboxtile(0,1,0,1)
newboxtile(0,0,1,1)
newboxtile(2,0,2,0)
newboxtile(1,1,0,0)
newboxtile(1,2,0,1)
newboxtile(1,1,0,2)
newboxtile(0,1,0,1)
newboxtile(0,1,0,1)
newboxtile(1,0,0,1)
newboxtile(2,0,0,0)

Global matchingboxtileangle=0,matchingboxtilecorners[3]
Function findmatchingboxtile(N,E,S,W)
matchingboxtileangle=0
For i=0 To 3
matchingboxtilecorners[i]=-1
Next
Local matches[3] ;did every angle match?
Local matchfound=-1
For j=0 To 3 ;each angle!
For b.boxtile=Each boxtile
If b\placed=0
matchfound=-1
matches[0]=0
matches[1]=0
matches[2]=0
matches[3]=0
If N=-1 Then matches[0]=1
If E=-1 Then matches[1]=1
If S=-1 Then matches[2]=1
If W=-1 Then matches[3]=1
For i=0 To 3
If matches[rotatedangleby(i,j)]=0 ;find a boxtile with a matching north tile!
 If (i=0 And N=b\corner[rotatedangleby(i,j)] ) Or (i=1 And E=b\corner[rotatedangleby(i,j)] ) Or(i=2 And S=b\corner[rotatedangleby(i,j)] )Or(i=3 And W=b\corner[rotatedangleby(i,j)] )
  matches[rotatedangleby(i,j)]=1
 EndIf
EndIf
Next
If matches[0]=1 And matches[1]=1 And matches[2]=1 And matches[3]=1
 matchingboxtileangle=j*90
 For ii=0 To 3
 If matchingboxtilecorners[rotatedangleby(ii,0)]=-1 Then matchingboxtilecorners[rotatedangleby(ii,0)]=b\corner[rotatedangleby(ii,j)]
 Next
 matchfound=b\no
 b\placed=1
 Exit
EndIf
EndIf
Next
If matchfound>-1 Then Exit
Next
Return matchfound
End Function

Function rotatedangleby(no,flipped)
no=no+flipped
If no>3 Then no=no-4
If no>3 Then no=no-4
Return no
End Function

  
  

Type tile
Field x,y,placed,angle,sprite
Field corner[4] ;goes North clockwise
;NSEW alignments:
;0: field
;1: path
;2: city
;4: river
End Type

Type incompletetile
Field x,y,angle
Field corner[4] ;goes North clockwise
;NSEW alignments:
;-1: nothing
;0: field
;1: path
;2: city
;4: river
End Type

Function newincompletetile(N=-1,E=-1,S=-1,W=-1,x,y)
Local found=0,foundtile
Local t.incompletetile
For tti.tile=Each tile
If tti\x=x And tti\y=y
 foundtile=1
 Exit
EndIf
Next
If foundtile=0
 For tt.incompletetile=Each incompletetile
 If tt\x=x And tt\y=y
  found=1
  Exit
 EndIf
 Next
 If found=1 Then t.incompletetile=tt
 If found=0
  t.incompletetile=New incompletetile
  t\corner[0]=-1:t\corner[1]=-1:t\corner[2]=-1:t\corner[3]=-1
 EndIf
 If t\corner[0]=-1 Then t\corner[0]=N
 If t\corner[1]=-1 Then t\corner[1]=E
 If t\corner[2]=-1 Then t\corner[2]=S
 If t\corner[3]=-1 Then t\corner[3]=W
 t\x=x
 t\y=y
EndIf
End Function


Function newtile(N,E,S,W,sprite=-1,angle=0)
t.tile=New tile
t\corner[0]=N
t\corner[1]=E
t\corner[2]=S
t\corner[3]=W
t\sprite=sprite
t\angle=angle
End Function

Function placetile(t.tile,x,y)
t\placed=1
t\x=x
t\y=y
newincompletetile(-1,-1,t\corner[0],-1,t\x,t\y-1)
newincompletetile(-1,-1,-1,t\corner[1],t\x+1,t\y)
newincompletetile(t\corner[2],-1,-1,-1,t\x,t\y+1)
newincompletetile(-1,t\corner[3],-1,-1,t\x-1,t\y)
End Function

Function countincompletetiles()
Local coun=0
For t.incompletetile=Each incompletetile
 coun=coun+1
Next
Return coun
End Function

Function completerandomincompletetile()
Local count=countincompletetiles()
Local rn=Rand(1,count)
Local c=1
For t.incompletetile=Each incompletetile
 If c=rn
  completeincompletetile(t)
 EndIf
 c=c+1
Next
End Function

Function completeincompletetile(tt.incompletetile)
Local oldway=0
If oldway=1
t.tile=New tile
 For i=0 To 4
 t\corner[i]=tt\corner[i]
 If t\corner[i]=-1
  t\corner[i]=Rand(0,4)
 EndIf
 Next
 placetile(t,tt\x,tt\y)
 Delete tt
Else
 ;stop
 Local fmbt=findmatchingboxtile(tt\corner[0],tt\corner[1],tt\corner[2],tt\corner[3])
 If fmbt>-1
  t.tile=New tile
  t\sprite=fmbt
  t\angle=matchingboxtileangle
  For i=0 To 3
   t\corner[i]=matchingboxtilecorners[i]
  Next
  placetile(t,tt\x,tt\y)
  Delete tt
 Else
  ;no match found! do nothing
 EndIf
EndIf
End Function



Function placelasttile(x,y)
t.tile=Last tile
placetile(t,x,y)
End Function

Function isthereatileat(x,y)
Local ret
For t.tile=Each tile
If t\x=x And t\y=y
 ret=1
 Exit
EndIf
Next
Return ret
End Function



Const gridsc=50
Global panx,pany
Function drawtiles()
For t.tile=Each tile
Local r,g,b
For i=0 To 3
r=70:g=255:b=70
If t\corner[i]=1 : r=200:g=200:b=200: EndIf
If t\corner[i]=2 : r=200:g=30:b=30: EndIf
If t\corner[i]=3 : r=50:g=50:b=255: EndIf
;;drawtexture debugtileedge,panx+(t\x*gridsc),pany+(t\y*gridsc),0.2,1,r,g,b,(i*90)+0,gridsc,gridsc,1,1
Next
If t\sprite>-1 Then drawtexture tilestex,panx+(t\x*gridsc),pany+(t\y*gridsc),1,1,255,255,255,(i*90)+t\angle,gridsc,gridsc,1,1,-1,-1,t\sprite
Next
For tt.incompletetile=Each incompletetile
For i=0 To 3
r=70:g=255:b=70
If tt\corner[i]=1 : r=200:g=200:b=200: EndIf
If tt\corner[i]=2 : r=200:g=30:b=30: EndIf
If tt\corner[i]=3 : r=50:g=50:b=255: EndIf
drawtexture debugtileedge,panx+(tt\x*gridsc),pany+(tt\y*gridsc),0.1,1,r,g,b,(i*90)+0,gridsc,gridsc,1,1
Next
Next
End Function

Function countunusedboxtiles()
Local count
For b.boxtile=Each boxtile
If b\placed=0
count=count+1
EndIf
Next
Return count
End Function



newtile(2,1,0,1,21,270):placelasttile(5,5)


SeedRnd MilliSecs()

While Not KeyHit(1)
If KeyHit(57)
For b.boxtile=Each boxtile ;refresh box of tiles
 b\placed=0
Next
EndIf
If countunusedboxtiles()>0 Then completerandomincompletetile
drawtiles()
panx=panx+((KeyDown(30)-KeyDown(32))*5)
pany=pany+((KeyDown(17)-KeyDown(31))*5)
Flip
Cls
Wend
End